clear all;

%% Roboter Parameter

%Roboter Basis
param_robot.R_0=eye(3);
param_robot.p_0=[0;0;0];

% Lngen
param_robot.d1 = 0.36;
param_robot.d2 = 0.2045;
param_robot.d3 = 0.2155;
param_robot.d4 = 0.552;

% Gravitation
param_robot.g_vec = [0; 0; -9.81];
param_robot.g = 9.81;

% Schwerpunkte in krperfestem Koordinatensystem
param_robot.sp1x = 0.0003;
param_robot.sp1y = 0.059;
param_robot.sp1z = 0.042;
param_robot.sp2x = 0;
param_robot.sp2y = 0.03;
param_robot.sp2z = 0.13;
param_robot.sp3x = 0;
param_robot.sp3y = 0.23;
param_robot.sp3z = 0.0195;

param_robot.sp1 = [param_robot.sp1x, param_robot.sp1y, param_robot.sp1z];
param_robot.sp2 = [param_robot.sp2x, param_robot.sp2y, param_robot.sp2z];
param_robot.sp3 = [param_robot.sp3x, param_robot.sp3y, param_robot.sp3z];

% Massen in kg
param_robot.m0 = 5;
param_robot.m1 = 4;
param_robot.m2 = 3;
param_robot.m3 = 2.7 + 1.7 + 1.8 + 0.3;

% Massentrgheitsmomente
param_robot.I1xx = 0.05;
param_robot.I1yy = 0.018;
param_robot.I1zz = 0.044;
param_robot.I1xy = 0;
param_robot.I1xz = 0;
param_robot.I1yz = 0;
param_robot.I1 = [param_robot.I1xx, param_robot.I1yy, param_robot.I1zz];

param_robot.I2xx = 0.08000000000000002;
param_robot.I2yy = 0.075;
param_robot.I2zz = 0.009999999999999998;
param_robot.I2xy = 0;
param_robot.I2xz = 0;
param_robot.I2yz = 0;
param_robot.I2 = [param_robot.I2xx, param_robot.I2yy, param_robot.I2zz];

param_robot.I3xx = 0.2091;
param_robot.I3yy = 0.0247;
param_robot.I3zz = 0.2030;
param_robot.I3xy = 0;
param_robot.I3xz = 0;
param_robot.I3yz = 0;
param_robot.I3 = [param_robot.I3xx, param_robot.I3yy, param_robot.I3zz];

%% TODO Aufgabe 3.1.

% statische Rotations Matrizen
param_robot.R_01 = [1 0 0; 0 1 0; 0 0 1;];
param_robot.R_12 = [1 0 0; 0 1 0; 0 0 1;];
param_robot.R_23 = [1 0 0; 0 1 0; 0 0 1;];
param_robot.R_3e = [1 0 0; 0 1 0; 0 0 1;];

% statische Verschiebungen
param_robot.d_01 = [0 0 0];
param_robot.d_12 = [0 0 0];
param_robot.d_23 = [0 0 0];
param_robot.d_3e = [0 0 0];

%% Parameter fr Simscape (nicht verndern !)
% iiwa_link 0
%joint1
param_robot.link__0.R__joint1 = param_robot.R_01;
param_robot.link__0.d__joint1 = param_robot.d_01;
%inertia
param_robot.link__0.R__inertiaOrigin = eye(3);
param_robot.link__0.d__inertiaOrigin = [-0.1, 0, 0.07000000000000001];

% iiwa_link_1
%joint1
param_robot.link__1.R__joint2 = param_robot.R_12;
param_robot.link__1.d__joint2 = param_robot.d_12;
%inertia
param_robot.link__1.R__inertiaOrigin = eye(3);
param_robot.link__1.d__inertiaOrigin = param_robot.sp1;      

% iiwa_link_2
%joint1
param_robot.link__2.R__joint3 = param_robot.R_23;
param_robot.link__2.d__joint3 = param_robot.d_23;
%inertia
param_robot.link__2.R__inertiaOrigin = eye(3);
param_robot.link__2.d__inertiaOrigin = param_robot.sp2;

% iiwa_link_3
%joint1
param_robot.link__3.R__ee = param_robot.R_3e;
param_robot.link__3.d__ee = param_robot.d_3e;
%inertia
param_robot.link__3.R__inertiaOrigin = eye(3);
param_robot.link__3.d__inertiaOrigin = param_robot.sp3;    

% Initial Conditions
param_robot.q_init_lm = [pi/2; pi/2; pi/2];
param_robot.q_p_init_lm = [0; 0; 0];

%% TODO Aufgabe 3.9.
% tau_required TODO
tau_weight = zeros(3, 1);

%% TODO Aufgabe 3.13.
% K fr inv. Kinematik TODO
param_robot.K = diag([1, 1, 1]);
param_robot.q_d_0 = [0, 0, 0];

%% Trajektorie fr inverse Kinematik
r = 0.2;
x0 = [0.670708543539568; 0; 0.959270658320270];
x1 = x0 + [0, r, -r]';
x2 = x1 + [0, -r, -r]';
x3 = x2 + [0, -r, r]';

% Mittelpunkt:
m = x0 - [0, 0, r]';

% Startwert
q0 = [pi/8, 0, -pi/4];